Scala Compiler2.13.5 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package interpreter
  Definition Classes
    nsc
-  class IMain extends Repl with Imports with PresentationCompilation with Closeable

  An interpreter for Scala code.

  An interpreter for Scala code.

  The main public entry points are compile(), interpret(), and bind(). The compile() method loads a complete Scala file. The interpret() method executes one line of Scala code at the request of the user. The bind() method binds an object to a variable that can then be used by later interpreted code.

  The overall approach is based on compiling the requested code and then using a Java classloader and Java reflection to run the code and access its results.

  In more detail, a single compiler instance is used to accumulate all successfully compiled or interpreted Scala code. To "interpret" a line of code, the compiler generates a fresh object that includes the line of code and which has public member(s) to export all variables defined by that code. To extract the result of an interpreted line to show the user, a second "result object" is created which imports the variables exported by the above object and then exports members called "$eval" and "$print". To accommodate user expressions that read from variables or methods defined in previous statements, "import" statements are used.

  This interpreter shares the strengths and weaknesses of using the full compiler-to-Java. The main strength is that interpreted code behaves exactly as does compiled code, including running at full speed. The main weakness is that redefining classes and methods is not handled properly, because rebinding at the Java level is technically difficult.

  Definition Classes
    interpreter
- ComputedImports
- PhaseDependentOps
- PresentationCompileResult
- ReadEvalPrint
- ReplTypeOps
- Request
- deconstruct
- exprTyper
- flatOp
- naming
- replOutput
- typerOp

c

scala.tools.nsc.interpreter.IMain

# ReplTypeOps

###

#### implicit class ReplTypeOps extends AnyRef

Source
  IMain.scala

Linear Supertypes
AnyRef, Any
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. ReplTypeOps
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Instance Constructors

1.  new ReplTypeOps(tp: Global.Type)

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##: Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from ReplTypeOps toany2stringadd[ReplTypeOps] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (ReplTypeOps, B)
   Implicit
     This member is added by an implicit conversion from ReplTypeOps toArrowAssoc[ReplTypeOps] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  def andAlso(fn: (Global.Type) => Global.Type): Global.Type
7.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
8.  def clone(): AnyRef
   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
9.  def ensuring(cond: (ReplTypeOps) => Boolean, msg: => Any): ReplTypeOps
   Implicit
     This member is added by an implicit conversion from ReplTypeOps toEnsuring[ReplTypeOps] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
10.  def ensuring(cond: (ReplTypeOps) => Boolean): ReplTypeOps
    Implicit
      This member is added by an implicit conversion from ReplTypeOps toEnsuring[ReplTypeOps] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: Boolean, msg: => Any): ReplTypeOps
    Implicit
      This member is added by an implicit conversion from ReplTypeOps toEnsuring[ReplTypeOps] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  def ensuring(cond: Boolean): ReplTypeOps
    Implicit
      This member is added by an implicit conversion from ReplTypeOps toEnsuring[ReplTypeOps] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
14.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
15.  def finalize(): Unit
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
16.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from ReplTypeOps toStringFormat[ReplTypeOps] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
17.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
18.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
19.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
20.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
21.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
22.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
23.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
24.  def toString(): String
    Definition Classes
      AnyRef → Any
25.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
26.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
27.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Deprecated Value Members

1.  def →[B](y: B): (ReplTypeOps, B)
   Implicit
     This member is added by an implicit conversion from ReplTypeOps toArrowAssoc[ReplTypeOps] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromReplTypeOps to any2stringadd[ReplTypeOps]

### Inherited by implicit conversion StringFormat fromReplTypeOps to StringFormat[ReplTypeOps]

### Inherited by implicit conversion Ensuring fromReplTypeOps to Ensuring[ReplTypeOps]

### Inherited by implicit conversion ArrowAssoc fromReplTypeOps to ArrowAssoc[ReplTypeOps]

### Ungrouped